import Qt 4.7

Item {
    id: xaqmlFolderSettingsPicker
    width: 250
    height: 364

    property bool enabled: true

    property string folderDefaultItemPriorityString : "0"
    property int repeaterDefaultItemPrioritySegmentSelected

    property string folderDefaultItemTypeString : "0"
    property int repeaterDefaultItemTypeSegmentSelected

    property int folderDefaultItemSecurityLevel : 0
    property int repeaterDefaultItemSecuritySegmentSelected

    signal folderDefaultItemPriorityStringResultUpdated()
    signal folderDefaultItemTypeStringResultUpdated()
    signal folderDefaultItemSecurityLevelResultUpdated()

    onFolderDefaultItemPriorityStringChanged: {
//        console.debug("onFolderDefaultItemPriorityStringChanged")
//        console.debug(folderDefaultItemPriorityString)

        // 0 = Low
        // 1 = Normal
        // 2 = Medium
        // 3 = High

        if (folderDefaultItemPriorityString.charAt(0) == "1") repeaterDefaultItemPrioritySegmentSelected = 1;
        else if (folderDefaultItemPriorityString.charAt(0) == "2") repeaterDefaultItemPrioritySegmentSelected = 2;
        else if (folderDefaultItemPriorityString.charAt(0) == "3") repeaterDefaultItemPrioritySegmentSelected = 3;
        else repeaterDefaultItemPrioritySegmentSelected = 0;

        segmentDefaultItemPriorityGrid.currentIndex = repeaterDefaultItemPrioritySegmentSelected
    }

    onFolderDefaultItemTypeStringChanged: {
//        console.debug("onFolderDefaultItemTypeStringChanged")
//        console.debug(folderDefaultItemTypeString)

        // 0 = Action
        // 1 = Information
        // 2 = Decision

        if (folderDefaultItemTypeString.charAt(0) == "1") repeaterDefaultItemTypeSegmentSelected = 1;
        else if (folderDefaultItemTypeString.charAt(0) == "2") repeaterDefaultItemTypeSegmentSelected = 2;
        else repeaterDefaultItemTypeSegmentSelected = 0;

        segmentDefaultItemTypeGrid.currentIndex = repeaterDefaultItemTypeSegmentSelected
    }

    onFolderDefaultItemSecurityLevelChanged: {
//        console.debug("onFolderDefaultItemSecurityLevelChanged")
//        console.debug(folderDefaultItemSecurityLevel)

        repeaterDefaultItemSecuritySegmentSelected = folderDefaultItemSecurityLevel
        segmentDefaultItemSecurityGrid.currentIndex = repeaterDefaultItemSecuritySegmentSelected
    }

    function updateFolderDefaultItemPriorityString() {
//        console.debug("updateFolderDefaultItemPriorityString")
//        console.debug(repeaterDefaultItemPrioritySegmentSelected)

        if (repeaterDefaultItemPrioritySegmentSelected == 1) folderDefaultItemPriorityString = "1"
        else if (repeaterDefaultItemPrioritySegmentSelected == 2) folderDefaultItemPriorityString = "2"
        else if (repeaterDefaultItemPrioritySegmentSelected == 3) folderDefaultItemPriorityString = "3"
        else folderDefaultItemPriorityString = "0"

//        console.debug(folderDefaultItemPriorityString)
        folderDefaultItemPriorityStringResultUpdated()
    }

    function updateFolderDefaultItemTypeString() {
//        console.debug("updateFolderDefaultItemTypeString")
//        console.debug(repeaterDefaultItemTypeSegmentSelected)

        if (repeaterDefaultItemTypeSegmentSelected == 1) folderDefaultItemTypeString = "1"
        else if (repeaterDefaultItemTypeSegmentSelected == 2) folderDefaultItemTypeString = "2"
        else folderDefaultItemTypeString = "0"

//        console.debug(folderDefaultItemTypeString)
        folderDefaultItemTypeStringResultUpdated()
    }

    function updateFolderDefaultItemSecurityLevel() {
//        console.debug("updateFolderDefaultItemSecurityLevel")
//        console.debug(repeaterDefaultItemSecuritySegmentSelected)

        folderDefaultItemSecurityLevel = repeaterDefaultItemSecuritySegmentSelected

//        console.debug(folderDefaultItemSecurityLevel)
        folderDefaultItemSecurityLevelResultUpdated()
    }

    ListModel {
        id: segmentDefaultItemPriorityModel

        ListElement {
            name: "Low"
            checked: "1"
        }
        ListElement {
            name: "Normal"
            checked: "0"
        }
        ListElement {
            name: "Medium"
            checked: "0"
        }
        ListElement {
            name: "High"
            checked: "0"
        }

        function i18n(index) {
            if (i18n["text"] === undefined) {
                i18n.text = [
                            qsTr("Low"),
                            qsTr("Normal"),
                            qsTr("Medium"),
                            qsTr("High")
                        ]
            }
            return i18n.text[index]
        }
    }

    ListModel {
        id: segmentDefaultItemTypeModel

        ListElement {
            name: "Action"
            checked: "1"
        }
        ListElement {
            name: "Information"
            checked: "0"
        }
        ListElement {
            name: "Decision"
            checked: "0"
        }

        function i18n(index) {
            if (i18n["text"] === undefined) {
                i18n.text = [
                            qsTr("Action"),
                            qsTr("Information"),
                            qsTr("Decision")
                        ]
            }
            return i18n.text[index]
        }
    }

    ListModel {
        id: segmentDefaultItemSecurityModel

        ListElement {
            name: "L0"
            checked: "1"
        }
        ListElement {
            name: "L1"
            checked: "0"
        }
        ListElement {
            name: "L2"
            checked: "0"
        }
        ListElement {
            name: "L3"
            checked: "0"
        }
        ListElement {
            name: "L4"
            checked: "0"
        }
        ListElement {
            name: "L5"
            checked: "0"
        }

        function i18n(index) {
            if (i18n["text"] === undefined) {
                i18n.text = [
                            qsTr("L0"),
                            qsTr("L1"),
                            qsTr("L2"),
                            qsTr("L3"),
                            qsTr("L4"),
                            qsTr("L5")
                        ]
            }
            return i18n.text[index]
        }
    }


    //
    // traffic light segment control
    //

    Item {
        id: repeatSegmentDefaultItemPriorityControl
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.bottom: parent.bottom

        Text {
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: -10
            anchors.leftMargin: 6
            height: 20

            color: "white"
            font.pixelSize: 12
            //font.family: "Helvetica"
            font.family: "Arial"
            font.bold: true
            smooth: true

            text: qsTr("Default Item Priority")
        }

        Rectangle {
            id: repeatSegmentDefaultItemPriorityControlRect
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: 10
            height: 25
            clip: true
            color: "black"

            GridView {
                id: segmentDefaultItemPriorityGrid
                anchors.fill: parent
                anchors.topMargin: 1
                anchors.leftMargin: 2
                anchors.rightMargin: 2

                cellWidth: parent.width / model.count - 2; cellHeight: parent.height - 4

                model: segmentDefaultItemPriorityModel
                delegate: segmentDefaultItemPriorityCellDelegate
                //highlight: Rectangle { color: "lightsteelblue"; radius: 5; smooth: true; border.color: "white"; border.width: 1}
                //highlight: Rectangle { color: "#3e3c3c"; radius: 5; smooth: true; border.color: "white"; border.width: 1}
                //focus: true
                highlight: Rectangle { color: "#40ffffff"; radius: 1; smooth: true; border.color: "white"; border.width: 1}

                onVisibleChanged: {
                    if (visible) {
                        segmentDefaultItemPriorityGrid.currentIndex = repeaterDefaultItemPrioritySegmentSelected;
                    }
                }

                onCurrentIndexChanged: {
//                    console.debug("segmentDefaultItemPriorityGrid onCurrentIndexChanged")
                    //repeatWeeklyDetailControl.visible = false

                    if (segmentDefaultItemPriorityGrid.currentIndex == 0) iconDefaultItemPriorityPreviewImage.source = "pics/PriorityDotsLow@2x.png"
                    else if (segmentDefaultItemPriorityGrid.currentIndex == 1) iconDefaultItemPriorityPreviewImage.source = "pics/PriorityDotsNormal@2x.png"
                    else if (segmentDefaultItemPriorityGrid.currentIndex == 2) iconDefaultItemPriorityPreviewImage.source = "pics/PriorityDotsMedium@2x.png"
                    else if (segmentDefaultItemPriorityGrid.currentIndex == 3) iconDefaultItemPriorityPreviewImage.source = "pics/PriorityDotsHigh@2x.png"
                }

                Component {
                    id: segmentDefaultItemPriorityCellDelegate

                    Item {
                        id: segmentDefaultItemPriorityCellDelegateItem
                        width: segmentDefaultItemPriorityGrid.cellWidth; height: segmentDefaultItemPriorityGrid.cellHeight

                        MouseArea {
                            anchors.fill: parent
                            onClicked: {
                                segmentDefaultItemPriorityGrid.currentIndex = index;
                                repeaterDefaultItemPrioritySegmentSelected = index;

                                updateFolderDefaultItemPriorityString();
                            }
                        }

//                        Column {
                        Item {
                            id: segmentDefaultItemPriorityCellDelegateColumn
                            anchors.topMargin: 2
                            anchors.bottomMargin: 2
                            anchors.left: parent.left
                            anchors.leftMargin: 1
                            anchors.right: parent.right
                            anchors.rightMargin: 1

                            Text {
                                //text: name;
                                text: segmentDefaultItemPriorityGrid.model.i18n(index);
                                font.family: "Arial";
                                font.bold: true;
                                //font.pointSize: 11;
                                font.pixelSize: 11
                                anchors.top: parent.top
                                anchors.topMargin: 4
                                anchors.horizontalCenter: parent.horizontalCenter
                                color: "white";
                                smooth: true;
                            }
                        }
                    }
                }
            }
        }
    }

    Rectangle {
        id: iconDefaultItemPriorityPreviewRect
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 36
        height: 60
        color:  "#55000000"

        Image {
            id: iconDefaultItemPriorityPreviewImage
            anchors.horizontalCenter: parent.horizontalCenter
            anchors.verticalCenter: parent.verticalCenter
        }

    }

    XAHDivisionLine {
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 96
    }

    //
    // DefaultItemType segment control
    //

    Item {
        id: repeatSegmentDefaultItemTypeControl
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 120
        anchors.bottom: parent.bottom

        Text {
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: -10
            anchors.leftMargin: 6
            height: 20

            color: "white"
            font.pixelSize: 12
            //font.family: "Helvetica"
            font.family: "Arial"
            font.bold: true
            smooth: true

            text: qsTr("Default Item Type")
        }

        Rectangle {
            id: repeatSegmentDefaultItemTypeControlRect
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: 10
            height: 25
            clip: true
            color: "black"

            GridView {
                id: segmentDefaultItemTypeGrid
                anchors.fill: parent
                anchors.topMargin: 1
                anchors.leftMargin: 2
                anchors.rightMargin: 2

                cellWidth: parent.width / model.count - 2; cellHeight: parent.height - 4

                model: segmentDefaultItemTypeModel
                delegate: segmentDefaultItemTypeCellDelegate
                //highlight: Rectangle { color: "lightsteelblue"; radius: 5; smooth: true; border.color: "white"; border.width: 1}
                //highlight: Rectangle { color: "#3e3c3c"; radius: 5; smooth: true; border.color: "white"; border.width: 1}
                //focus: true
                highlight: Rectangle { color: "#40ffffff"; radius: 1; smooth: true; border.color: "white"; border.width: 1}

                onVisibleChanged: {
                    if (visible) {
                        segmentDefaultItemTypeGrid.currentIndex = repeaterDefaultItemTypeSegmentSelected;
                    }
                }

                onCurrentIndexChanged: {
//                    console.debug("segmentDefaultItemTypeGrid onCurrentIndexChanged")
                    //repeatWeeklyDetailControl.visible = false

                    if (segmentDefaultItemTypeGrid.currentIndex == 0) iconDefaultItemTypePreviewImage.source = "pics/aid-box-action60px.png"
                    else if (segmentDefaultItemTypeGrid.currentIndex == 1) iconDefaultItemTypePreviewImage.source = "pics/aid-box-information60px.png"
                    else if (segmentDefaultItemTypeGrid.currentIndex == 2) iconDefaultItemTypePreviewImage.source = "pics/aid-box-decision60px.png"
                }

                Component {
                    id: segmentDefaultItemTypeCellDelegate

                    Item {
                        id: segmentDefaultItemTypeCellDelegateItem
                        width: segmentDefaultItemTypeGrid.cellWidth; height: segmentDefaultItemTypeGrid.cellHeight

                        MouseArea {
                            anchors.fill: parent
                            onClicked: {
                                segmentDefaultItemTypeGrid.currentIndex = index;
                                repeaterDefaultItemTypeSegmentSelected = index;

                                updateFolderDefaultItemTypeString();
                            }
                        }

//                        Column {
                        Item {
                            id: segmentDefaultItemTypeCellDelegateColumn
                            anchors.topMargin: 2
                            anchors.bottomMargin: 2
                            anchors.left: parent.left
                            anchors.leftMargin: 1
                            anchors.right: parent.right
                            anchors.rightMargin: 1

                            Text {
                                //text: name;
                                text: segmentDefaultItemTypeGrid.model.i18n(index);
                                font.family: "Arial";
                                font.bold: true;
                                //font.pointSize: 11;
                                font.pixelSize: 8
                                anchors.top: parent.top
                                anchors.topMargin: 4
                                anchors.horizontalCenter: parent.horizontalCenter
                                color: "white";
                                smooth: true;
                            }
                        }
                    }
                }
            }
        }
    }

    Rectangle {
        id: iconDefaultItemTypePreviewRect
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 156
        height: 60
        color:  "#55000000"

        Image {
            id: iconDefaultItemTypePreviewImage
            anchors.horizontalCenter: parent.horizontalCenter
            anchors.verticalCenter: parent.verticalCenter
        }

    }

    XAHDivisionLine {
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 216
    }

    //
    // DefaultItemSecurity control
    //

    Item {
        id: repeatSegmentDefaultItemSecurityControl
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 240
        anchors.bottom: parent.bottom

        Text {
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: -10
            anchors.leftMargin: 6
            height: 20

            color: "white"
            font.pixelSize: 12
            //font.family: "Helvetica"
            font.family: "Arial"
            font.bold: true
            smooth: true

            text: qsTr("Default Item Security Level")
        }

        Rectangle {
            id: repeatSegmentDefaultItemSecurityControlRect
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: 10
            height: 25
            clip: true
            color: "black"

            GridView {
                id: segmentDefaultItemSecurityGrid
                anchors.fill: parent
                anchors.topMargin: 1
                anchors.leftMargin: 2
                anchors.rightMargin: 2

                cellWidth: parent.width / model.count - 2; cellHeight: parent.height - 4

                model: segmentDefaultItemSecurityModel
                delegate: segmentDefaultItemSecurityCellDelegate
                //highlight: Rectangle { color: "lightsteelblue"; radius: 5; smooth: true; border.color: "white"; border.width: 1}
                //highlight: Rectangle { color: "#3e3c3c"; radius: 5; smooth: true; border.color: "white"; border.width: 1}
                //focus: true
                highlight: Rectangle { color: "#40ffffff"; radius: 1; smooth: true; border.color: "white"; border.width: 1}

                onVisibleChanged: {
                    if (visible) {
                        segmentDefaultItemSecurityGrid.currentIndex = repeaterDefaultItemSecuritySegmentSelected;
                    }
                }

                onCurrentIndexChanged: {
//                    console.debug("segmentDefaultItemSecurityGrid onCurrentIndexChanged")
                    //repeatWeeklyDetailControl.visible = false

                    iconDefaultItemSecurityPreviewImage.source = "qrc:icons2/actionBarIconLockL" + segmentDefaultItemSecurityGrid.currentIndex + "_21px.png";

                    if (segmentDefaultItemSecurityGrid.currentIndex == 0) iconDefaultItemSecurityPreviewText.text = qsTr("Unclassified")
                    else if (segmentDefaultItemSecurityGrid.currentIndex == 1) iconDefaultItemSecurityPreviewText.text = qsTr("Controlled Unclassified")
                    else if (segmentDefaultItemSecurityGrid.currentIndex == 2) iconDefaultItemSecurityPreviewText.text = qsTr("Restricted")
                    else if (segmentDefaultItemSecurityGrid.currentIndex == 3) iconDefaultItemSecurityPreviewText.text = qsTr("Confidential")
                    else if (segmentDefaultItemSecurityGrid.currentIndex == 4) iconDefaultItemSecurityPreviewText.text = qsTr("Secret")
                    else if (segmentDefaultItemSecurityGrid.currentIndex == 5) iconDefaultItemSecurityPreviewText.text = qsTr("Top Secret")
                }

                Component {
                    id: segmentDefaultItemSecurityCellDelegate

                    Item {
                        id: segmentDefaultItemSecurityCellDelegateItem
                        width: segmentDefaultItemSecurityGrid.cellWidth; height: segmentDefaultItemSecurityGrid.cellHeight

                        MouseArea {
                            anchors.fill: parent
                            onClicked: {
                                segmentDefaultItemSecurityGrid.currentIndex = index;
                                repeaterDefaultItemSecuritySegmentSelected = index;

                                updateFolderDefaultItemSecurityLevel();
                            }
                        }

//                        Column {
                        Item {
                            id: segmentDefaultItemSecurityCellDelegateColumn
                            anchors.topMargin: 2
                            anchors.bottomMargin: 2
                            anchors.left: parent.left
                            anchors.leftMargin: 1
                            anchors.right: parent.right
                            anchors.rightMargin: 1

                            Text {
                                //text: name;
                                text: segmentDefaultItemSecurityGrid.model.i18n(index)
                                font.family: "Arial";
                                font.bold: true;
                                //font.pointSize: 11;
                                font.pixelSize: 11
                                anchors.top: parent.top
                                anchors.topMargin: 4
                                anchors.horizontalCenter: parent.horizontalCenter
                                color: "white";
                                smooth: true;
                            }
                        }
                    }
                }
            }
        }
    }

    Rectangle {
        id: iconDefaultItemSecurityPreviewRect
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 276
        height: 60
        color:  "#55000000"

        Image {
            id: iconDefaultItemSecurityPreviewImage
            anchors.left: parent.left
            anchors.top: parent.top
            anchors.topMargin: 19
            anchors.leftMargin: 30

        }

        Text {
            id: iconDefaultItemSecurityPreviewText
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: 25
            anchors.leftMargin: 60
            height: 20

            color: "white"
            font.pixelSize: 12
            //font.family: "Helvetica"
            font.family: "Arial"
            font.bold: false
            smooth: true

            text: qsTr("Default Item Security Level")
        }

    }

    XAHDivisionLine {
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 336
    }

}
